{"openapi":"3.0.0","info":{"title":"DigitalOcean API","version":"2.0","description":"","license":{"name":"Apache 2.0","url":"https://www.apache.org/licenses/LICENSE-2.0.html"},"contact":{"name":"DigitalOcean API Team","email":"api-engineering@digitalocean.com"},"termsOfService":"https://www.digitalocean.com/legal/terms-of-service-agreement/"},"servers":[{"url":"https://api.digitalocean.com","description":"production"}],"tags":[{"name":"Public APIs Introduction","x-displayName":"Introduction","x-traitTag":true,"description":"The DigitalOcean API allows you to manage Droplets and resources within the\nDigitalOcean cloud in a simple, programmatic way using conventional HTTP requests.\n\nAll of the functionality that you are familiar with in the DigitalOcean\ncontrol panel is also available through the API, allowing you to script the\ncomplex actions that your situation requires.\n\nThe API documentation will start with a general overview about the design\nand technology that has been implemented, followed by reference information\nabout specific endpoints.\n\n## Requests\n\nAny tool that is fluent in HTTP can communicate with the API simply by\nrequesting the correct URI. Requests should be made using the HTTPS protocol\nso that traffic is encrypted. The interface responds to different methods\ndepending on the action required.\n\n|Method|Usage|\n|--- |--- |\n|GET|For simple retrieval of information about your account, Droplets, or environment, you should use the GET method.  The information you request will be returned to you as a JSON object. The attributes defined by the JSON object can be used to form additional requests.  Any request using the GET method is read-only and will not affect any of the objects you are querying.|\n|DELETE|To destroy a resource and remove it from your account and environment, the DELETE method should be used.  This will remove the specified object if it is found.  If it is not found, the operation will return a response indicating that the object was not found. This idempotency means that you do not have to check for a resource's availability prior to issuing a delete command, the final state will be the same regardless of its existence.|\n|PUT|To update the information about a resource in your account, the PUT method is available. Like the DELETE Method, the PUT method is idempotent.  It sets the state of the target using the provided values, regardless of their current values. Requests using the PUT method do not need to check the current attributes of the object.|\n|PATCH|Some resources support partial modification. In these cases, the PATCH method is available. Unlike PUT which generally requires a complete representation of a resource, a PATCH request is a set of instructions on how to modify a resource updating only specific attributes.|\n|POST|To create a new object, your request should specify the POST method. The POST request includes all of the attributes necessary to create a new object.  When you wish to create a new object, send a POST request to the target endpoint.|\n|HEAD|Finally, to retrieve metadata information, you should use the HEAD method to get the headers.  This returns only the header of what would be returned with an associated GET request. Response headers contain some useful information about your API access and the results that are available for your request. For instance, the headers contain your current rate-limit value and the amount of time available until the limit resets. It also contains metrics about the total number of objects found, pagination information, and the total content length.|\n\n\n## HTTP Statuses\n\nAlong with the HTTP methods that the API responds to, it will also return\nstandard HTTP statuses, including error codes.\n\nIn the event of a problem, the status will contain the error code, while the\nbody of the response will usually contain additional information about the\nproblem that was encountered.\n\nIn general, if the status returned is in the 200 range, it indicates that\nthe request was fulfilled successfully and that no error was encountered.\n\nReturn codes in the 400 range typically indicate that there was an issue\nwith the request that was sent. Among other things, this could mean that you\ndid not authenticate correctly, that you are requesting an action that you\ndo not have authorization for, that the object you are requesting does not\nexist, or that your request is malformed.\n\nIf you receive a status in the 500 range, this generally indicates a\nserver-side problem. This means that we are having an issue on our end and\ncannot fulfill your request currently.\n\n400 and 500 level error responses will include a JSON object in their body,\nincluding the following attributes:\n\n|Name|Type|Description|\n|--- |--- |--- |\n|id|string|A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be \"not_found.\"|\n|message|string|A message providing additional information about the error, including details to help resolve it when possible.|\n|request_id|string|Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.|\n\n### Example Error Response\n\n```\n    HTTP/1.1 403 Forbidden\n    {\n      \"id\":       \"forbidden\",\n      \"message\":  \"You do not have access for the attempted action.\"\n    }\n```\n\n## Responses\n\nWhen a request is successful, a response body will typically be sent back in\nthe form of a JSON object. An exception to this is when a DELETE request is\nprocessed, which will result in a successful HTTP 204 status and an empty\nresponse body.\n\nInside of this JSON object, the resource root that was the target of the\nrequest will be set as the key. This will be the singular form of the word\nif the request operated on a single object, and the plural form of the word\nif a collection was processed.\n\nFor example, if you send a GET request to `/v2/droplets/$DROPLET_ID` you\nwill get back an object with a key called \"`droplet`\". However, if you send\nthe GET request to the general collection at `/v2/droplets`, you will get\nback an object with a key called \"`droplets`\".\n\nThe value of these keys will generally be a JSON object for a request on a\nsingle object and an array of objects for a request on a collection of\nobjects.\n\n### Response for a Single Object\n\n```json\n    {\n        \"droplet\": {\n            \"name\": \"example.com\"\n            . . .\n        }\n    }\n```\n\n### Response for an Object Collection\n\n```json\n    {\n        \"droplets\": [\n            {\n                \"name\": \"example.com\"\n                . . .\n            },\n            {\n                \"name\": \"second.com\"\n                . . .\n            }\n        ]\n    }\n```\n\n## Meta\n\nIn addition to the main resource root, the response may also contain a\n`meta` object. This object contains information about the response itself.\n\nThe `meta` object contains a `total` key that is set to the total number of\nobjects returned by the request. This has implications on the `links` object\nand pagination.\n\nThe `meta` object will only be displayed when it has a value. Currently, the\n`meta` object will have a value when a request is made on a collection (like\n`droplets` or `domains`).\n\n\n### Sample Meta Object\n\n```json\n    {\n        . . .\n        \"meta\": {\n            \"total\": 43\n        }\n        . . .\n    }\n```\n\n## Links & Pagination\n\nThe `links` object is returned as part of the response body when pagination\nis enabled. By default, 20 objects are returned per page. If the response\ncontains 20 objects or fewer, no `links` object will be returned. If the\nresponse contains more than 20 objects, the first 20 will be returned along\nwith the `links` object.\n\nYou can request a different pagination limit or force pagination by\nappending `?per_page=` to the request with the number of items you would\nlike per page. For instance, to show only two results per page, you could\nadd `?per_page=2` to the end of your query. The maximum number of results\nper page is 200.\n\nThe `links` object contains a `pages` object. The `pages` object, in turn,\ncontains keys indicating the relationship of additional pages. The values of\nthese are the URLs of the associated pages. The keys will be one of the\nfollowing:\n\n*   **first**: The URI of the first page of results.\n*   **prev**: The URI of the previous sequential page of results.\n*   **next**: The URI of the next sequential page of results.\n*   **last**: The URI of the last page of results.\n\nThe `pages` object will only include the links that make sense. So for the\nfirst page of results, no `first` or `prev` links will ever be set. This\nconvention holds true in other situations where a link would not make sense.\n\n### Sample Links Object\n\n```json\n    {\n        . . .\n        \"links\": {\n            \"pages\": {\n                \"last\": \"https://api.digitalocean.com/v2/images?page=2\",\n                \"next\": \"https://api.digitalocean.com/v2/images?page=2\"\n            }\n        }\n        . . .\n    }\n```\n\n## Rate Limit\n\nRequests through the API are rate limited per OAuth token. Current rate limits:\n\n*   5,000 requests per hour\n*   250 requests per minute (5% of the hourly total)\n\nOnce you exceed either limit, you will be rate limited until the next cycle\nstarts. Space out any requests that you would otherwise issue in bursts for\nthe best results.\n\nThe rate limiting information is contained within the response headers of\neach request. The relevant headers are:\n\n*   **ratelimit-limit**: The number of requests that can be made per hour.\n*   **ratelimit-remaining**: The number of requests that remain before you hit your request limit. See the information below for how the request limits expire.\n*   **ratelimit-reset**: This represents the time when the oldest request will expire. The value is given in [Unix epoch time](http://en.wikipedia.org/wiki/Unix_time). See below for more information about how request limits expire.\n\nMore rate limiting information is returned only within burst limit error response headers:\n*   **retry-after**: The number of seconds to wait before making another request when rate limited.\n\nAs long as the `ratelimit-remaining` count is above zero, you will be able\nto make additional requests.\n\nThe way that a request expires and is removed from the current limit count\nis important to understand. Rather than counting all of the requests for an\nhour and resetting the `ratelimit-remaining` value at the end of the hour,\neach request instead has its own timer.\n\nThis means that each request contributes toward the `ratelimit-remaining`\ncount for one complete hour after the request is made. When that request's\ntimer runs out, it is no longer counted towards the request limit.\n\nThis has implications on the meaning of the `ratelimit-reset` header as\nwell. Because the entire rate limit is not reset at one time, the value of\nthis header is set to the time when the _oldest_ request will expire.\n\nKeep this in mind if you see your `ratelimit-reset` value change, but not\nmove an entire hour into the future.\n\nIf the `ratelimit-remaining` reaches zero, subsequent requests will receive\na 429 error code until the request reset has been reached. \n\n`ratelimit-remaining` reaching zero can also indicate that the \"burst limit\" of 250 \nrequests per minute limit was met, even if the 5,000 requests per hour limit was not. \nIn this case, the 429 error response will include a `retry-after` header to indicate how \nlong to wait (in seconds) until the request may be retried.\n\nYou can see the format of the response in the examples. \n\n**Note:** The following endpoints have special rate limit requirements that\nare independent of the limits defined above.\n\n*   Only 10 `GET` requests to the `/v2/account/keys` endpoint to list SSH keys can be made per 60 seconds.\n*   Only 5 requests to any and all `v2/cdn/endpoints` can be made per 10 seconds. This includes `v2/cdn/endpoints`, \n    `v2/cdn/endpoints/$ENDPOINT_ID`, and `v2/cdn/endpoints/$ENDPOINT_ID/cache`.\n*   Only 50 strings within the `files` json struct in the `v2/cdn/endpoints/$ENDPOINT_ID/cache` [payload](https://docs.digitalocean.com/reference/api/api-reference/#operation/cdn_purge_cache) \n    can be requested every 20 seconds.\n\n### Sample Rate Limit Headers\n\n```\n    . . .\n    ratelimit-limit: 1200\n    ratelimit-remaining: 1193\n    rateLimit-reset: 1402425459\n    . . .\n```\n\n  ### Sample Rate Limit Headers When Burst Limit is Reached:\n\n```\n    . . .\n    ratelimit-limit: 5000\n    ratelimit-remaining: 0\n    rateLimit-reset: 1402425459\n    retry-after: 29\n    . . .\n```\n\n### Sample Rate Exceeded Response\n\n```\n    429 Too Many Requests\n    {\n            id: \"too_many_requests\",\n            message: \"API Rate limit exceeded.\"\n    }\n```\n\n## Curl Examples\n\nThroughout this document, some example API requests will be given using the\n`curl` command. This will allow us to demonstrate the various endpoints in a\nsimple, textual format.\n  \n  These examples assume that you are using a Linux or macOS command line. To run\nthese commands on a Windows machine, you can either use cmd.exe, PowerShell, or WSL:\n\n* For cmd.exe, use the `set VAR=VALUE` [syntax](https://docs.microsoft.com/en-us/windows-server/administration/windows-commands/set_1)\nto define environment variables, call them with `%VAR%`, then replace all backslashes (`\\`) in the examples with carets (`^`).\n\n* For PowerShell, use the `$Env:VAR = \"VALUE\"` [syntax](https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_environment_variables?view=powershell-7.2)\nto define environment variables, call them with `$Env:VAR`, then replace `curl` with `curl.exe` and all backslashes (`\\`) in the examples with backticks (`` ` ``).\n\n* WSL is a compatibility layer that allows you to emulate a Linux terminal on a Windows machine.\nInstall WSL with our [community tutorial](https://www.digitalocean.com/community/tutorials/how-to-install-the-windows-subsystem-for-linux-2-on-microsoft-windows-10), \nthen follow this API documentation normally.\n\nThe names of account-specific references (like Droplet IDs, for instance)\nwill be represented by variables. For instance, a Droplet ID may be\nrepresented by a variable called `$DROPLET_ID`. You can set the associated\nvariables in your environment if you wish to use the examples without\nmodification.\n\nThe first variable that you should set to get started is your OAuth\nauthorization token. The next section will go over the details of this, but\nyou can set an environmental variable for it now.\n\nGenerate a token by going to the [Apps & API](https://cloud.digitalocean.com/settings/applications)\nsection of the DigitalOcean control panel. Use an existing token if you have\nsaved one, or generate a new token with the \"Generate new token\" button.\nCopy the generated token and use it to set and export the TOKEN variable in\nyour environment as the example shows.\n\nYou may also wish to set some other variables now or as you go along. For\nexample, you may wish to set the `DROPLET_ID` variable to one of your\nDroplet IDs since this will be used frequently in the API.\n\nIf you are following along, make sure you use a Droplet ID that you control\nso that your commands will execute correctly.\n\nIf you need access to the headers of a response through `curl`, you can pass\nthe `-i` flag to display the header information along with the body. If you\nare only interested in the header, you can instead pass the `-I` flag, which\nwill exclude the response body entirely.\n\n\n### Set and Export your OAuth Token\n\n```\nexport DIGITALOCEAN_TOKEN=your_token_here\n```\n\n### Set and Export a Variable\n\n```\nexport DROPLET_ID=1111111\n```\n\n## Parameters\n\nThere are two different ways to pass parameters in a request with the API.\n\nWhen passing parameters to create or update an object, parameters should be\npassed as a JSON object containing the appropriate attribute names and\nvalues as key-value pairs. When you use this format, you should specify that\nyou are sending a JSON object in the header. This is done by setting the\n`Content-Type` header to `application/json`. This ensures that your request\nis interpreted correctly.\n\nWhen passing parameters to filter a response on GET requests, parameters can\nbe passed using standard query attributes. In this case, the parameters\nwould be embedded into the URI itself by appending a `?` to the end of the\nURI and then setting each attribute with an equal sign. Attributes can be\nseparated with a `&`. Tools like `curl` can create the appropriate URI when\ngiven parameters and values; this can also be done using the `-F` flag and\nthen passing the key and value as an argument. The argument should take the\nform of a quoted string with the attribute being set to a value with an\nequal sign.\n\n### Pass Parameters as a JSON Object\n\n```\n    curl -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n        -H \"Content-Type: application/json\" \\\n        -d '{\"name\": \"example.com\", \"ip_address\": \"127.0.0.1\"}' \\\n        -X POST \"https://api.digitalocean.com/v2/domains\"\n```\n\n### Pass Filter Parameters as a Query String\n\n```\n     curl -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n         -X GET \\\n         \"https://api.digitalocean.com/v2/images?private=true\"\n```\n\n## Cross Origin Resource Sharing\n\nIn order to make requests to the API from other domains, the API implements\nCross Origin Resource Sharing (CORS) support.\n\nCORS support is generally used to create AJAX requests outside of the domain\nthat the request originated from. This is necessary to implement projects\nlike control panels utilizing the API. This tells the browser that it can\nsend requests to an outside domain.\n\nThe procedure that the browser initiates in order to perform these actions\n(other than GET requests) begins by sending a \"preflight\" request. This sets\nthe `Origin` header and uses the `OPTIONS` method. The server will reply\nback with the methods it allows and some of the limits it imposes. The\nclient then sends the actual request if it falls within the allowed\nconstraints.\n\nThis process is usually done in the background by the browser, but you can\nuse curl to emulate this process using the example provided. The headers\nthat will be set to show the constraints are:\n\n*   **Access-Control-Allow-Origin**: This is the domain that is sent by the client or browser as the origin of the request. It is set through an `Origin` header.\n*   **Access-Control-Allow-Methods**: This specifies the allowed options for requests from that domain. This will generally be all available methods.\n*   **Access-Control-Expose-Headers**: This will contain the headers that will be available to requests from the origin domain.\n*   **Access-Control-Max-Age**: This is the length of time that the access is considered valid. After this expires, a new preflight should be sent.\n*   **Access-Control-Allow-Credentials**: This will be set to `true`. It basically allows you to send your OAuth token for authentication.\n\nYou should not need to be concerned with the details of these headers,\nbecause the browser will typically do all of the work for you.\n"},{"name":"1-Click Applications","description":"1-Click applications are pre-built Droplet images or Kubernetes apps with software,\nfeatures, and configuration details already set up for you. They can be found in the\n[DigitalOcean Marketplace](https://marketplace.digitalocean.com/)."},{"name":"Account","description":"Provides information about your current account."},{"name":"Actions","description":"Actions are records of events that have occurred on the resources in your account.\nThese can be things like rebooting a Droplet, or transferring an image to a new region.\n\nAn action object is created every time one of these actions is initiated. The action\nobject contains information about the current status of the action, start and complete\ntimestamps, and the associated resource type and ID.\n\nEvery action that creates an action object is available through this endpoint. Completed\nactions are not removed from this list and are always available for querying.\n\n**Note:** You can pass the following HTTP header with the request to have the API return\nthe `reserved_ips` stanza instead of the `floating_ips` stanza:\n\n- `Accept: application/vnd.digitalocean.reserveip+json`"},{"name":"Add-Ons","description":"Add-ons are third-party applications that can be added to your DigitalOcean account.\nThey are available through the [DigitalOcean Marketplace](https://marketplace.digitalocean.com/).\nAdd-ons can be used to enhance the functionality of your existing resources or to provide\nadditional services.\n\nThe Add-Ons API allows you to manage these resources, including creating, listing, and retrieving\ndetails about specific add-on resources."},{"name":"Apps","description":"App Platform is a Platform-as-a-Service (PaaS) offering from DigitalOcean that allows\ndevelopers to publish code directly to DigitalOcean servers without worrying about the\nunderlying infrastructure.\n\nMost API operations are centered around a few core object types. Following are the\ndefinitions of these types. These definitions will be omitted from the operation-specific\ndocumentation.\n\nFor documentation on app specifications (`AppSpec` objects), please refer to the\n[product documentation](https://docs.digitalocean.com/products/app-platform/reference/app-spec/))."},{"name":"Billing","description":"The billing endpoints allow you to retrieve your account balance, invoices,\nbilling history, and insights.\n\n**Balance:** By sending requests to the `/v2/customers/my/balance` endpoint, you can\nretrieve the balance information for the requested customer account.\n\n**Invoices:** [Invoices](https://docs.digitalocean.com/platform/billing/invoices/)\nare generated on the first of each month for every DigitalOcean\ncustomer. An invoice preview is generated daily, which can be accessed\nwith the `preview` keyword in place of `$INVOICE_UUID`. To interact with\ninvoices, you will generally send requests to the invoices endpoint at\n`/v2/customers/my/invoices`.\n\n**Billing History:** Billing history is a record of billing events for your account.\nFor example, entries may include events like payments made, invoices\nissued, or credits granted. To interact with invoices, you\nwill generally send requests to the invoices endpoint at\n`/v2/customers/my/billing_history`.\n\n**Billing Insights:** Day-over-day changes in billing resource usage based on nightly invoice items,\nincluding total amount, region, SKU, and description for a specified date range.\nIt is important to note that the daily resource usage may not reflect month-end billing totals when totaled for\na given month as nightly invoice items do not necessarily encompass all invoicing factors for the entire month.\n  `v2/billing/{account_urn}/insights/{start_date}/{end_date}` where account_urn is the URN of the customer\naccount, can be a team (do:team:uuid) or an organization (do:teamgroup:uuid). The date range specified by\nstart_date and end_date must be in YYYY-MM-DD format."},{"name":"Block Storage","description":"[DigitalOcean Block Storage Volumes](https://docs.digitalocean.com/products/volumes/)\nprovide expanded storage capacity for your Droplets and can be moved\nbetween Droplets within a specific region.\n\nVolumes function as raw block devices, meaning they appear to the\noperating system as locally attached storage which can be formatted using\nany file system supported by the OS. They may be created in sizes from\n1GiB to 16TiB.\n\nBy sending requests to the `/v2/volumes` endpoint, you can list, create, or\ndelete volumes as well as attach and detach them from Droplets"},{"name":"Block Storage Actions","description":"Block storage actions are commands that can be given to a DigitalOcean\nBlock Storage Volume. An example would be detaching or attaching a volume\nfrom a Droplet. These requests are made on the\n`/v2/volumes/$VOLUME_ID/actions` endpoint.\n\nAn action object is returned. These objects hold the current status of the\nrequested action."},{"name":"BYOIP Prefixes","description":"Bring your own IP (BYOIP) lets you provision your own IPv4 network prefixes\nto your account, then assign those IPs to your DigitalOcean resources.\nBYOIP supports the following features:\n* IPv4 addresses\n* Network sizes of anywhere from `/24` (256 addresses) to `/18` (16,384 addresses)\n* Same API and management interface as our existing reserved IPs feature\n* Assignable to Droplets only"},{"name":"CDN Endpoints","description":"Content hosted in DigitalOcean's object storage solution,\n[Spaces](https://docs.digitalocean.com/products/spaces/),\ncan optionally be served by our globally distributed Content Delivery\nNetwork (CDN). By sending requests to `/v2/cdn/endpoints`, you can list,\ncreate, or delete CDN Endpoints as well as purge cached content. To use a\ncustom subdomain to access the CDN Endpoint, provide the ID of a\nDigitalOcean managed TLS certificate and the fully qualified domain name\nfor the custom subdomain.\n\nCDN endpoints have a rate limit of five requests per 10 seconds."},{"name":"Certificates","description":"In order to perform SSL termination on load balancers, DigitalOcean offers\ntwo types of [SSL certificate management](https://docs.digitalocean.com/platform/teams/manage-certificates):\n\n* **Custom**: User-generated certificates may be uploaded to DigitalOcean\nwhere they will be placed in a fully encrypted and isolated storage system.\n\n* **Let's Encrypt**: Certificates may be automatically generated by\nDigitalOcean utilizing an integration with Let's Encrypt, the free and\nopen certificate authority. These certificates will also be automatically\nrenewed as required."},{"name":"Container Registry","description":"DigitalOcean offers the ability for you to create a\n[private container registry](https://docs.digitalocean.com/products/container-registry/)\nto store your Docker images for use with your Kubernetes clusters. This\ncontainer registry runs inside the same datacenters as your cluster,\nensuring reliable and performant rollout of image deployments.\n\nYou can only create one registry per DigitalOcean account, but you can use\nthat registry to create as many repositories as you wish."},{"name":"Container Registries","description":"DigitalOcean now supports up to nine additional registries (for a total maximum of 10) per team\nif your container registry uses the Professional subscription plan. The storage is shared among\nthe registries. This set of new APIs is backward compatible with `/v2/registry`. However, if you\ncreate more than one registry under a Professional plan, some of the `/v2/registry` APIs would not work.\nHence, it is recommended to use `/v2/registries` for multiple registries."},{"name":"Databases","description":"DigitalOcean's [managed database service](https://docs.digitalocean.com/products/databases)\nsimplifies the creation and management of highly available database clusters. Currently, it\noffers support for [PostgreSQL](http://docs.digitalocean.com/products/databases/postgresql/),\n[Caching](https://docs.digitalocean.com/products/databases/redis/),\n[Valkey](https://docs.digitalocean.com/products/databases/valkey/),\n[MySQL](https://docs.digitalocean.com/products/databases/mysql/),\n[MongoDB](https://docs.digitalocean.com/products/databases/mongodb/), and\n[OpenSearch](https://docs.digitalocean.com/products/databases/opensearch/).\n\nBy sending requests to the `/v2/databases` endpoint, you can list, create, or delete\ndatabase clusters as well as scale the size of a cluster, add or remove read-only replicas,\nand manage other configuration details.\n\nDatabase clusters may be deployed in a multi-node, high-availability configuration.\nIf your machine type is above the basic nodes, your node plan is above the smallest option,\nor you are running MongoDB, you may additionally include up to two standby nodes in your cluster.\n\nThe size of individual nodes in a database cluster is represented by a human-readable slug,\nwhich is used in some of the following requests. Each slug denotes the node's identifier,\nCPU count, and amount of RAM, in that order.\n\nFor a list of currently available database slugs and options, use the `/v2/databases/options` endpoint or use the\n`doctl databases options` [command](https://docs.digitalocean.com/reference/doctl/reference/databases/options)."},{"name":"Dedicated Inference","description":"[Dedicated Inference](https://docs.digitalocean.com/products/agent-platform/dedicated-inference/)\ndelivers scalable production-grade LLM hosting on DigitalOcean. Create, list, get, update,\nand delete Dedicated Inference instances; manage accelerators, CA certificate, sizes,\nGPU model config, and access tokens."},{"name":"Domain Records","description":"Domain record resources are used to set or retrieve information about the\nindividual DNS records configured for a domain. This allows you to build\nand manage DNS zone files by adding and modifying individual records for a\ndomain.\n\nThe [DigitalOcean DNS management interface](https://docs.digitalocean.com/products/networking/dns/)\nallows you to configure the following DNS records:\n\nName  | Description                                                                                                                                        |\n------|----------------------------------------------------------------------------------------------------------------------------------------------------|\nA     | This record type is used to map an IPv4 address to a hostname.                                                                                     |\nAAAA  | This record type is used to map an IPv6 address to a hostname.                                                                                     |\nCAA   | As specified in RFC-6844, this record type can be used to restrict which certificate authorities are permitted to issue certificates for a domain. |\nCNAME | This record type defines an alias for your canonical hostname (the one defined by an A or AAAA record).                                            |\nMX    | This record type is used to define the mail exchanges used for the domain.                                                                         |\nNS    | This record type defines the name servers that are used for this zone.                                                                             |\nTXT   | This record type is used to associate a string of text with a hostname, primarily used for verification.                                           |\nSRV   | This record type specifies the location (hostname and port number) of servers for specific services.                                               |\nSOA   | This record type defines administrative information about the zone. Can only have ttl changed, cannot be deleted                                   |"},{"name":"Domains","description":"Domain resources are domain names that you have purchased from a domain\nname registrar that you are managing through the\n[DigitalOcean DNS interface](https://docs.digitalocean.com/products/networking/dns/).\n\nThis resource establishes top-level control over each domain. Actions that\naffect individual domain records should be taken on the\n[Domain Records](#tag/Domain-Records) resource."},{"name":"Droplet Actions","description":"Droplet actions are tasks that can be executed on a Droplet. These can be\nthings like rebooting, resizing, snapshotting, etc.\n\nDroplet action requests are generally targeted at one of the \"actions\"\nendpoints for a specific Droplet. The specific actions are usually\ninitiated by sending a POST request with the action and arguments as\nparameters.\n\nDroplet action requests create a Droplet actions object, which can be used\nto get information about the status of an action. Creating a Droplet\naction is asynchronous: the HTTP call will return the action object before\nthe action has finished processing on the Droplet. The current status of\nan action can be retrieved from either the Droplet actions endpoint or the\nglobal actions endpoint. If a Droplet action is uncompleted it may block\nthe creation of a subsequent action for that Droplet, the locked attribute\nof the Droplet will be true and attempts to create a Droplet action will\nfail with a status of 422."},{"name":"Droplets","description":"A [Droplet](https://docs.digitalocean.com/products/droplets/) is a DigitalOcean\nvirtual machine. By sending requests to the Droplet endpoint, you can\nlist, create, or delete Droplets.\n\nSome of the attributes will have an object value. The `region` and `image`\nobjects will all contain the standard attributes of their associated\ntypes. Find more information about each of these objects in their\nrespective sections."},{"name":"Droplet Autoscale Pools","description":"Droplet autoscale pools manage automatic horizontal scaling for your applications based on resource usage (CPU, memory, or both) or a static configuration."},{"name":"Embeddings","description":"Text embedding vectors via `POST /v1/embeddings` on the\n[Serverless Inference](https://docs.digitalocean.com/reference/api/api-reference/#tag/Serverless-Inference) base URL\n`https://inference.do-ai.run` (bearer model access key)."},{"name":"Firewalls","description":"[DigitalOcean Cloud Firewalls](https://docs.digitalocean.com/products/networking/firewalls/)\nprovide the ability to restrict network access to and from a Droplet\nallowing you to define which ports will accept inbound or outbound\nconnections. By sending requests to the `/v2/firewalls` endpoint, you can\nlist, create, or delete firewalls as well as modify access rules."},{"name":"Floating IP Actions","description":"As of 16 June 2022, we have renamed the Floating IP product to [Reserved IPs](https://docs.digitalocean.com/reference/api/api-reference/#tag/Reserved-IPs).\nThe Reserved IP product's endpoints function the exact same way as Floating IPs.\nThe only difference is the name change throughout the URLs and fields.\nFor example, the `floating_ips` field is now the `reserved_ips` field.\nThe Floating IP endpoints will remain active until fall 2023 before being\npermanently deprecated.\n\nWith the exception of the [Projects API](https://docs.digitalocean.com/reference/api/api-reference/#tag/Projects),\nwe will reflect this change as an additional field in the responses across the API\nwhere the `floating_ip` field is used. For example, the Droplet metadata response\nwill contain the field `reserved_ips` in addition to the `floating_ips` field.\nFloating IPs retrieved using the Projects API will retain the original name.\n\nFloating IP actions are commands that can be given to a DigitalOcean\nfloating IP. These requests are made on the actions endpoint of a specific\nfloating IP.\n\nAn action object is returned. These objects hold the current status of the\nrequested action."},{"name":"Floating IPs","description":"As of 16 June 2022, we have renamed the Floating IP product to [Reserved IPs](https://docs.digitalocean.com/reference/api/api-reference/#tag/Reserved-IPs).\nThe Reserved IP product's endpoints function the exact same way as Floating IPs.\nThe only difference is the name change throughout the URLs and fields.\nFor example, the `floating_ips` field is now the `reserved_ips` field.\nThe Floating IP endpoints will remain active until fall 2023 before being\npermanently deprecated.\n\nWith the exception of the [Projects API](https://docs.digitalocean.com/reference/api/api-reference/#tag/Projects),\nwe will reflect this change as an additional field in the responses across the API\nwhere the `floating_ip` field is used. For example, the Droplet metadata response\nwill contain the field `reserved_ips` in addition to the `floating_ips` field.\nFloating IPs retrieved using the Projects API will retain the original name.\n\n[DigitalOcean Floating IPs](https://docs.digitalocean.com/products/networking/reserved-ips/)\nare publicly-accessible static IP addresses that can be mapped to one of\nyour Droplets. They can be used to create highly available setups or other\nconfigurations requiring movable addresses.\n\nFloating IPs are bound to a specific region."},{"name":"Functions","description":"[Serverless functions](https://docs.digitalocean.com/products/functions) are blocks of code that run on demand without the need to manage any infrastructure.\nYou can develop functions on your local machine and then deploy them to a namespace using `doctl`, the [official DigitalOcean CLI tool](https://docs.digitalocean.com/reference/doctl).\n\nThe Serverless Functions API currently only supports creating and managing namespaces."},{"name":"GradientAI Platform","description":"The API lets you build GPU-powered AI agents with pre-built or custom foundation models, function and agent routes, and RAG pipelines with knowledge bases."},{"name":"Image Actions","description":"Image actions are commands that can be given to a DigitalOcean image. In\ngeneral, these requests are made on the actions endpoint of a specific\nimage.\n\nAn image action object is returned. These objects hold the current status\nof the requested action."},{"name":"Images","description":"A DigitalOcean [image](https://docs.digitalocean.com/products/images/) can be\nused to create a Droplet and may come in a number of flavors. Currently,\nthere are five types of images: snapshots, backups, applications,\ndistributions, and custom images.\n\n* [Snapshots](https://docs.digitalocean.com/products/snapshots/) provide\na full copy of an existing Droplet instance taken on demand.\n\n* [Backups](https://docs.digitalocean.com/products/backups/) are similar\nto snapshots but are created automatically at regular intervals when\nenabled for a Droplet.\n\n* [Custom images](https://docs.digitalocean.com/products/custom-images/)\nare Linux-based virtual machine images (raw, qcow2, vhdx, vdi, and vmdk\nformats are supported) that you may upload for use on DigitalOcean.\n\n* Distributions are the public Linux distributions that are available to\nbe used as a base to create Droplets.\n\n* Applications, or [1-Click Apps](https://docs.digitalocean.com/products/marketplace/),\nare distributions pre-configured with additional software.\n\nTo interact with images, you will generally send requests to the images\nendpoint at /v2/images."},{"name":"Kubernetes","description":"[DigitalOcean Kubernetes](https://docs.digitalocean.com/products/kubernetes/)\nallows you to quickly deploy scalable and secure Kubernetes clusters. By\nsending requests to the `/v2/kubernetes/clusters` endpoint, you can list,\ncreate, or delete clusters as well as scale node pools up and down,\nrecycle individual nodes, and retrieve the kubeconfig file for use with\na cluster."},{"name":"Load Balancers","description":"[DigitalOcean Load Balancers](https://docs.digitalocean.com/products/networking/load-balancers/)\nprovide a way to distribute traffic across multiple Droplets. By sending\nrequests to the `/v2/load_balancers` endpoint, you can list, create, or\ndelete load balancers as well as add or remove Droplets, forwarding rules,\nand other configuration details."},{"name":"Monitoring","description":"The DigitalOcean Monitoring API makes it possible to programmatically retrieve metrics as well as configure alert\npolicies based on these metrics. The Monitoring API can help you gain insight into how your apps are performing\nand consuming resources."},{"name":"NFS","description":"NFS lets you create fully managed, POSIX-compliant network file storage that delivers secure,\nhigh-performance shared storage right inside your VPC. This enables seamless data sharing across Droplets in a VPC."},{"name":"NFS Actions","description":"NFS actions are tasks that can be executed on an NFS share. These can be\nthings like resizing, snapshotting, etc."},{"name":"Partner Network Connect","description":"Partner Network Connect lets you establish high-bandwidth, low-latency\nnetwork connections directly between DigitalOcean VPC networks and other\npublic cloud providers or on-premises datacenters."},{"name":"Project Resources","description":"Project Resources are resources that can be grouped into your projects.\nYou can group resources (like Droplets, Spaces, load balancers, domains,\nand floating IPs) in ways that align with the applications you host on\nDigitalOcean.\n\n### Supported Resource Types Examples\n\nProjects resources are identified by uniform resource names or URNs. A\nvalid URN has the following format: `do:resource_type:resource_id`. The\nfollowing resource types are supported:\n\nResource Type      | Example URN\n-------------------|------------\nApp Platform App   | `do:app:be5aab85-851b-4cab-b2ed-98d5a63ba4e8`\nDatabase           | `do:dbaas:83c7a55f-0d84-4760-9245-aba076ec2fb2`\nDomain             | `do:domain:example.com`\nDroplet            | `do:droplet:4126873`\nFloating IP        | `do:floatingip:192.168.99.100`\nKubernetes Cluster | `do:kubernetes:bd5f5959-5e1e-4205-a714-a914373942af`\nLoad Balancer      | `do:loadbalancer:39052d89-8dd4-4d49-8d5a-3c3b6b365b5b`\nSpace              | `do:space:my-website-assets`\nVolume             | `do:volume:6fc4c277-ea5c-448a-93cd-dd496cfef71f`\n\n### Resource Status Codes\n\nWhen assigning and retrieving resources in projects, a `status` attribute\nis returned that indicates if a resource was successfully retrieved or\nassigned. The status codes can be one of the following:\n\nStatus Code        | Explanation\n-------------------|------------\n`ok`               | There was no problem retrieving or assigning a resource.\n`not_found`        | The resource was not found.\n`assigned`         | The resource was successfully assigned.\n`already_assigned` | The resource was already assigned.\n`service_down`     | There was a problem retrieving or assigning a resource. Please try again."},{"name":"Projects","description":"Projects allow you to organize your resources into groups that fit the way\nyou work. You can group resources (like Droplets, Spaces, load balancers,\ndomains, and floating IPs) in ways that align with the applications\nyou host on DigitalOcean."},{"name":"Regions","description":"Provides information about DigitalOcean data center regions."},{"name":"Reserved IP Actions","description":"As of 16 June 2022, we have renamed the [Floating IP](https://docs.digitalocean.com/reference/api/api-reference/#tag/Floating-IPs)\nproduct to Reserved IPs. The Reserved IP product's endpoints function the exact\nsame way as Floating IPs. The only difference is the name change throughout the\nURLs and fields. For example, the `floating_ips` field is now the `reserved_ips` field.\nThe Floating IP endpoints will remain active until fall 2023 before being\npermanently deprecated.\n\nWith the exception of the [Projects API](https://docs.digitalocean.com/reference/api/api-reference/#tag/Projects),\nwe will reflect this change as an additional field in the responses across the API\nwhere the `floating_ip` field is used. For example, the Droplet metadata response\nwill contain the field `reserved_ips` in addition to the `floating_ips` field.\nFloating IPs retrieved using the Projects API will retain the original name.\n\nReserved IP actions are commands that can be given to a DigitalOcean\nreserved IP. These requests are made on the actions endpoint of a specific\nreserved IP.\n\nAn action object is returned. These objects hold the current status of the\nrequested action."},{"name":"Reserved IPs","description":"As of 16 June 2022, we have renamed the [Floating IP](https://docs.digitalocean.com/reference/api/api-reference/#tag/Floating-IPs)\nproduct to Reserved IPs. The Reserved IP product's endpoints function the exact\nsame way as Floating IPs. The only difference is the name change throughout the\nURLs and fields. For example, the `floating_ips` field is now the `reserved_ips` field.\nThe Floating IP endpoints will remain active until fall 2023 before being\npermanently deprecated.\n\nWith the exception of the [Projects API](https://docs.digitalocean.com/reference/api/api-reference/#tag/Projects),\nwe will reflect this change as an additional field in the responses across the API\nwhere the `floating_ip` field is used. For example, the Droplet metadata response\nwill contain the field `reserved_ips` in addition to the `floating_ips` field.\nFloating IPs retrieved using the Projects API will retain the original name.\n\nDigitalOcean Reserved IPs are publicly-accessible static IP addresses that can be\nmapped to one of your Droplets. They can be used to create highly available\nsetups or other configurations requiring movable addresses.\n\nReserved IPs are bound to a specific region."},{"name":"Reserved IPv6","description":"DigitalOcean Reserved IPv6s are publicly-accessible static IP addresses that can be\nmapped to one of your Droplets. They can be used to create highly available\nsetups or other configurations requiring movable addresses.\n\nReserved IPv6s are bound to a specific region."},{"name":"Reserved IPv6 Actions","description":"Reserved IPv6 actions requests are made on the actions endpoint of a specific\nreserved IPv6.\n\nAn action object is returned. These objects hold the current status of the\nrequested action."},{"name":"Security","description":"Security CSPM endpoints for scans, scan findings, and settings."},{"name":"Sizes","description":"The sizes objects represent different packages of hardware resources that\ncan be used for Droplets. When a Droplet is created, a size must be\nselected so that the correct resources can be allocated.\n\nEach size represents a plan that bundles together specific sets of\nresources. This includes the amount of RAM, the number of virtual CPUs,\ndisk space, and transfer. The size object also includes the pricing\ndetails and the regions that the size is available in."},{"name":"Snapshots","description":"[Snapshots](https://docs.digitalocean.com/products/snapshots/) are saved\ninstances of a Droplet or a block storage volume, which is reflected in\nthe `resource_type` attribute. In order to avoid problems with compressing\nfilesystems, each defines a `min_disk_size` attribute which is the minimum\nsize of the Droplet or volume disk when creating a new resource from the\nsaved snapshot.\n\nTo interact with snapshots, you will generally send requests to the\nsnapshots endpoint at `/v2/snapshots`."},{"name":"Spaces Keys","description":"Spaces keys authenticate requests to DigitalOcean Spaces Buckets.\nYou can create, list, update, or delete Spaces keys by sending requests to\nto the `/v2/spaces/keys` endpoint."},{"name":"SSH Keys","description":"Manage SSH keys available on your account."},{"name":"Tags","description":"A tag is a label that can be applied to a resource (currently Droplets,\nImages, Volumes, Volume Snapshots, and Database clusters) in order to\nbetter organize or facilitate the lookups and actions on it.\n\nTags have two attributes: a user defined `name` attribute and an embedded\n`resources` attribute with information about resources that have been tagged."},{"name":"Uptime","description":"[DigitalOcean Uptime Checks](https://docs.digitalocean.com/products/uptime/) provide the ability to monitor your endpoints from around the world, and alert you when they're slow, unavailable, or SSL certificates are expiring.\nTo interact with Uptime, you will generally send requests to the Uptime endpoint at `/v2/uptime/`."},{"name":"VPC NAT Gateways","description":"[VPC NAT Gateways](https://docs.digitalocean.com/products/networking/vpc/how-to/create-nat-gateway/)\nallow resources in a private VPC to access the public internet without\nexposing them to incoming traffic.\n\nBy sending requests to the `/v2/vpc_nat_gateways` endpoint, you can create,\nconfigure, list, and delete VPC NAT Gateways as well as retrieve information\nabout the resources assigned to them."},{"name":"VPC Peerings","description":"[VPC Peerings](https://docs.digitalocean.com/products/networking/vpc/how-to/create-peering/)\njoin two VPC networks with a secure, private connection. This allows\nresources in those networks to connect to each other's private IP addresses\nas if they were in the same network."},{"name":"VPCs","description":"[VPCs (virtual private clouds)](https://docs.digitalocean.com/products/networking/vpc/)\nallow you to create virtual networks containing resources that can\ncommunicate with each other in full isolation using private IP addresses.\n\nBy sending requests to the `/v2/vpcs` endpoint, you can create, configure,\nlist, and delete custom VPCs as well as retrieve information about the\nresources assigned to them."},{"name":"Inference Introduction","x-displayName":"Introduction","x-traitTag":true,"description":"The DigitalOcean Gradient™ AI Agentic Cloud provides inference capabilities through\ntwo API variants:\n\n- **Serverless Inference**: Access serverless inference models using an inference key\n  at `https://inference.do-ai.run`.\n- **Agent Inference**: Integrate multi-agent workflows into your AI applications using\n  a customer-specific agent endpoint.\n\nThese APIs are independent of the main DigitalOcean control-plane API (`https://api.digitalocean.com`).\n\n## Base URLs\n\n| API | Base URL |\n|-----|----------|\n| Serverless Inference | `https://inference.do-ai.run` |\n| Agent Inference | `https://{your-agent-url}.agents.do-ai.run` |\n\n## Requests\n\nAny tool that is fluent in HTTP can communicate with the API simply by\nrequesting the correct URI. Requests should be made using the HTTPS protocol\nso that traffic is encrypted. The interface responds to different methods\ndepending on the action required.\n\n|Method|Usage|\n|--- |--- |\n|GET|For simple retrieval of information about your account, Droplets, or environment, you should use the GET method.  The information you request will be returned to you as a JSON object. The attributes defined by the JSON object can be used to form additional requests.  Any request using the GET method is read-only and will not affect any of the objects you are querying.|\n|DELETE|To destroy a resource and remove it from your account and environment, the DELETE method should be used.  This will remove the specified object if it is found.  If it is not found, the operation will return a response indicating that the object was not found. This idempotency means that you do not have to check for a resource's availability prior to issuing a delete command, the final state will be the same regardless of its existence.|\n|PUT|To update the information about a resource in your account, the PUT method is available. Like the DELETE Method, the PUT method is idempotent.  It sets the state of the target using the provided values, regardless of their current values. Requests using the PUT method do not need to check the current attributes of the object.|\n|PATCH|Some resources support partial modification. In these cases, the PATCH method is available. Unlike PUT which generally requires a complete representation of a resource, a PATCH request is a set of instructions on how to modify a resource updating only specific attributes.|\n|POST|To create a new object, your request should specify the POST method. The POST request includes all of the attributes necessary to create a new object.  When you wish to create a new object, send a POST request to the target endpoint.|\n|HEAD|Finally, to retrieve metadata information, you should use the HEAD method to get the headers.  This returns only the header of what would be returned with an associated GET request. Response headers contain some useful information about your API access and the results that are available for your request. For instance, the headers contain your current rate-limit value and the amount of time available until the limit resets. It also contains metrics about the total number of objects found, pagination information, and the total content length.|\n\n## HTTP Statuses\n\nAlong with the HTTP methods that the API responds to, it will also return\nstandard HTTP statuses, including error codes.\n\nIn the event of a problem, the status will contain the error code, while the\nbody of the response will usually contain additional information about the\nproblem that was encountered.\n\nIn general, if the status returned is in the 200 range, it indicates that\nthe request was fulfilled successfully and that no error was encountered.\n\nReturn codes in the 400 range typically indicate that there was an issue\nwith the request that was sent. Among other things, this could mean that you\ndid not authenticate correctly, that you are requesting an action that you\ndo not have authorization for, that the object you are requesting does not\nexist, or that your request is malformed.\n\nIf you receive a status in the 500 range, this generally indicates a\nserver-side problem. This means that we are having an issue on our end and\ncannot fulfill your request currently.\n\n400 and 500 level error responses will include a JSON object in their body,\nincluding the following attributes:\n\n|Name|Type|Description|\n|--- |--- |--- |\n|id|string|A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be \"not_found.\"|\n|message|string|A message providing additional information about the error, including details to help resolve it when possible.|\n|request_id|string|Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.|\n\n### Example Error Response\n\n```\n    HTTP/1.1 403 Forbidden\n    {\n      \"id\":       \"forbidden\",\n      \"message\":  \"You do not have access for the attempted action.\"\n    }\n```\n\n## Responses\n\nWhen a request is successful, a response body will typically be sent back in\none of two formats depending on the request parameters:\n\n### JSON Response (Non-Streaming)\n\nBy default, or when `stream` is set to `false`, the API returns a complete JSON\nresponse once the inference is finished. The response contains the full generated\ncontent in a single payload.\n\n```json\n    {\n        \"id\": \"chatcmpl-abc123\",\n        \"object\": \"chat.completion\",\n        \"created\": 1677858242,\n        \"model\": \"meta-llama/Llama-3.3-70B-Instruct\",\n        \"choices\": [\n            {\n                \"index\": 0,\n                \"message\": {\n                    \"role\": \"assistant\",\n                    \"content\": \"Hello! How can I help you today?\"\n                },\n                \"finish_reason\": \"stop\"\n            }\n        ],\n        \"usage\": {\n            \"prompt_tokens\": 10,\n            \"completion_tokens\": 12,\n            \"total_tokens\": 22\n        }\n    }\n```\n\n### Streaming Response (Server-Sent Events)\n\nWhen `stream` is set to `true`, the API returns the response as Server-Sent Events\n(SSE) with content type `text/event-stream`. This allows you to receive tokens as\nthey are generated, providing a more responsive user experience.\n\nEach event in the stream is prefixed with `data: ` and contains a JSON object\nrepresenting a chunk of the response. The stream ends with a `data: [DONE]` message.\n\n```\n    data: {\"id\":\"chatcmpl-abc123\",\"object\":\"chat.completion.chunk\",\"created\":1677858242,\"model\":\"meta-llama/Llama-3.3-70B-Instruct\",\"choices\":[{\"index\":0,\"delta\":{\"role\":\"assistant\",\"content\":\"Hello\"},\"finish_reason\":null}]}\n\n    data: {\"id\":\"chatcmpl-abc123\",\"object\":\"chat.completion.chunk\",\"created\":1677858242,\"model\":\"meta-llama/Llama-3.3-70B-Instruct\",\"choices\":[{\"index\":0,\"delta\":{\"content\":\"!\"},\"finish_reason\":null}]}\n\n    data: {\"id\":\"chatcmpl-abc123\",\"object\":\"chat.completion.chunk\",\"created\":1677858242,\"model\":\"meta-llama/Llama-3.3-70B-Instruct\",\"choices\":[{\"index\":0,\"delta\":{},\"finish_reason\":\"stop\"}]}\n\n    data: [DONE]\n```\n\nTo consume streaming responses, read the response body line by line, parse each\n`data:` line as JSON, and process the `delta.content` field to build up the\ncomplete response incrementally.\n\n## Rate Limit\n\nRequests through the API are rate limited per OAuth token. Current rate limits:\n\n*   5,000 requests per hour\n*   250 requests per minute (5% of the hourly total)\n\nOnce you exceed either limit, you will be rate limited until the next cycle\nstarts. Space out any requests that you would otherwise issue in bursts for\nthe best results.\n\nThe rate limiting information is contained within the response headers of\neach request. The relevant headers are:\n\n*   **ratelimit-limit**: The number of requests that can be made per hour.\n*   **ratelimit-remaining**: The number of requests that remain before you hit your request limit. See the information below for how the request limits expire.\n*   **ratelimit-reset**: This represents the time when the oldest request will expire. The value is given in [Unix epoch time](http://en.wikipedia.org/wiki/Unix_time). See below for more information about how request limits expire.\n\nMore rate limiting information is returned only within burst limit error response headers:\n*   **retry-after**: The number of seconds to wait before making another request when rate limited.\n\nAs long as the `ratelimit-remaining` count is above zero, you will be able\nto make additional requests.\n\nThe way that a request expires and is removed from the current limit count\nis important to understand. Rather than counting all of the requests for an\nhour and resetting the `ratelimit-remaining` value at the end of the hour,\neach request instead has its own timer.\n\nThis means that each request contributes toward the `ratelimit-remaining`\ncount for one complete hour after the request is made. When that request's\ntimer runs out, it is no longer counted towards the request limit.\n\nThis has implications on the meaning of the `ratelimit-reset` header as\nwell. Because the entire rate limit is not reset at one time, the value of\nthis header is set to the time when the _oldest_ request will expire.\n\nKeep this in mind if you see your `ratelimit-reset` value change, but not\nmove an entire hour into the future.\n\nIf the `ratelimit-remaining` reaches zero, subsequent requests will receive\na 429 error code until the request reset has been reached. \n\n`ratelimit-remaining` reaching zero can also indicate that the \"burst limit\" of 250 \nrequests per minute limit was met, even if the 5,000 requests per hour limit was not. \nIn this case, the 429 error response will include a `retry-after` header to indicate how \nlong to wait (in seconds) until the request may be retried.\n\nYou can see the format of the response in the examples.\n\n### Sample Rate Limit Headers\n\n```\n    . . .\n    ratelimit-limit: 1200\n    ratelimit-remaining: 1193\n    rateLimit-reset: 1402425459\n    . . .\n```\n\n### Sample Rate Limit Headers When Burst Limit is Reached:\n\n```\n    . . .\n    ratelimit-limit: 5000\n    ratelimit-remaining: 0\n    rateLimit-reset: 1402425459\n    retry-after: 29\n    . . .\n```\n\n### Sample Rate Exceeded Response\n\n```\n    429 Too Many Requests\n    {\n            id: \"too_many_requests\",\n            message: \"API Rate limit exceeded.\"\n    }\n```\n"},{"name":"Serverless Inference","description":"DigitalOcean Gradient™ AI Agentic Cloud allows access to serverless inference models.\nYou can access models by providing an inference key.\n\n**Note:** The Serverless Inference API uses a separate base URL (`https://inference.do-ai.run`)\nand is independent of the main DigitalOcean control-plane API (`https://api.digitalocean.com`)."},{"name":"Agent Inference","description":"DigitalOcean Gradient™ AI Agentic Cloud allows you to create multi-agent workflows\nto power your AI applications. This allows developers to integrate agents into your\nAI applications.\n\n**Note:** The Agent Inference API uses a customer-specific base URL (the agent endpoint)\nand is independent of the main DigitalOcean control-plane API (`https://api.digitalocean.com`)."},{"name":"Batch Inference","description":"Batch Inference is an asynchronous processing capability designed to help\nyou scale high-volume AI projects more efficiently. Ideal for heavy-duty\nworkloads like large-scale data classification, evaluations, and content\nenrichment, you can submit thousands or even millions of requests in a\nsingle job with a guaranteed results window of 24 hours. By utilizing\noff-peak GPU capacity, Batch Inference provides high-performance LLM\naccess at a significantly reduced price point compared to standard\nsynchronous APIs, making it a cost-effective choice for non-interactive\nworkloads."}],"x-tagGroups":[{"name":"Public APIs","tags":["Public APIs Introduction","1-Click Applications","Account","Actions","Add-Ons","Apps","Billing","Block Storage","Block Storage Actions","BYOIP Prefixes","CDN Endpoints","Certificates","Container Registry","Container Registries","Databases","Dedicated Inference","Domain Records","Domains","Droplet Actions","Droplets","Droplet Autoscale Pools","Firewalls","Floating IP Actions","Floating IPs","Functions","GradientAI Platform","Image Actions","Images","Kubernetes","Load Balancers","Monitoring","NFS","NFS Actions","Partner Network Connect","Project Resources","Projects","Regions","Reserved IP Actions","Reserved IPs","Reserved IPv6","Reserved IPv6 Actions","Security","Sizes","Snapshots","Spaces Keys","SSH Keys","Tags","Uptime","VPC NAT Gateways","VPC Peerings","VPCs"]},{"name":"Inference APIs","tags":["Inference Introduction","Agent Inference","Batch Inference","Embeddings","Serverless Inference"]}],"paths":{"/v2/1-clicks":{"get":{"operationId":"oneClicks_list","summary":"List 1-Click Applications","description":"To list all available 1-Click applications, send a GET request to `/v2/1-clicks`. The `type` may\nbe provided as query paramater in order to restrict results to a certain type of 1-Click, for\nexample: `/v2/1-clicks?type=droplet`. Current supported types are `kubernetes` and `droplet`.\n\nThe response will be a JSON object with a key called `1_clicks`. This will be set to an array of\n1-Click application data, each of which will contain the the slug and type for the 1-Click.\n","tags":["1-Click Applications"],"parameters":[{"$ref":"#/components/parameters/oneClicks_type"}],"responses":{"200":{"$ref":"#/components/responses/oneClicks_all"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\"  \\\n  \"https://api.digitalocean.com/v2/1-clicks\""},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=\"\")\n\none_click_apps = client.one_clicks.list()"}],"security":[{"bearer_auth":[]}]}},"/v2/1-clicks/kubernetes":{"post":{"operationId":"oneClicks_install_kubernetes","summary":"Install Kubernetes 1-Click Applications","description":"To install a Kubernetes 1-Click application on a cluster, send a POST request to\n`/v2/1-clicks/kubernetes`. The `addon_slugs` and `cluster_uuid` must be provided as body\nparameter in order to specify which 1-Click application(s) to install. To list all available\n1-Click Kubernetes applications, send a request to `/v2/1-clicks?type=kubernetes`.\n","tags":["1-Click Applications"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/oneClicks_create"}}}},"responses":{"200":{"$ref":"#/components/responses/oneClicks_create"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X POST \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  -d '{\"addon_slugs\": [\"kube-state-metrics\", \"loki\"], \"cluster_uuid\": \"50a994b6-c303-438f-9495-7e896cfe6b08\"}'' \\\n  \"https://api.digitalocean.com/v2/1-clicks/kubernetes\""},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\ninstall_req = {\n    \"addon_slugs\": [\"kube-state-metrics\", \"loki\"],\n    \"cluster_uuid\": \"50a994b6-c303-438f-9495-7e896cfe6b08\",\n}\ninstall_resp = client.one_clicks.install_kubernetes(install_req)"}],"security":[{"bearer_auth":["kubernetes:update","addon:create"]}]}},"/v2/account":{"get":{"operationId":"account_get","summary":"Get User Information","description":"To show information about the current user account, send a GET request to `/v2/account`.","tags":["Account"],"responses":{"200":{"$ref":"#/components/responses/account"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/account\""},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.getenv(\"$DIGITALOCEAN_TOKEN\"))\n\naccount_info = client.account.get()"}],"security":[{"bearer_auth":["account:read"]}]}},"/v2/account/keys":{"get":{"operationId":"sshKeys_list","summary":"List All SSH Keys","description":"To list all of the keys in your account, send a GET request to `/v2/account/keys`. The response will be a JSON object with a key set to `ssh_keys`. The value of this will be an array of ssh_key objects, each of which contains the standard ssh_key attributes.","tags":["SSH Keys"],"parameters":[{"$ref":"#/components/parameters/per_page"},{"$ref":"#/components/parameters/page"}],"responses":{"200":{"$ref":"#/components/responses/sshKeys_all"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/account/keys\""},{"lang":"Go","source":"import (\n    \"context\"\n    \"os\"\n\n    \"github.com/digitalocean/godo\"\n)\n\nfunc main() {\n    token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n    client := godo.NewFromToken(token)\n    ctx := context.TODO()\n\n    opt := &godo.ListOptions{\n        Page:    1,\n        PerPage: 200,\n    }\n\n    keys, _, err := client.Keys.List(ctx, opt)\n}"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nssh_keys = client.ssh_keys.all\nssh_keys.each"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\nresp = client.ssh_keys.list()"}],"security":[{"bearer_auth":["ssh_key:read"]}]},"post":{"operationId":"sshKeys_create","summary":"Create a New SSH Key","description":"To add a new SSH public key to your DigitalOcean account, send a POST request to `/v2/account/keys`. Set the `name` attribute to the name you wish to use and the `public_key` attribute to the full public key you are adding.","tags":["SSH Keys"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/sshKeys"}}}},"responses":{"201":{"$ref":"#/components/responses/sshKeys_new"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X POST \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  -d '{\"name\":\"My SSH Public Key\",\"public_key\":\"ssh-rsa AEXAMPLEaC1yc2EAAAADAQABAAAAQQDDHr/jh2Jy4yALcK4JyWbVkPRaWmhck3IgCoeOO3z1e2dBowLh64QAM+Qb72pxekALga2oi4GvT+TlWNhzPH4V example\"}' \\\n  \"https://api.digitalocean.com/v2/account/keys\" "},{"lang":"Go","source":"import (\n    \"context\"\n    \"os\"\n\n    \"github.com/digitalocean/godo\"\n)\n\nfunc main() {\n    token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n    client := godo.NewFromToken(token)\n    ctx := context.TODO()\n\n    createRequest := &godo.KeyCreateRequest{\n        Name:      \"My SSH Public Key\",\n        PublicKey: \"ssh-rsa AEXAMPLEaC1yc2EAAAADAQABAAAAQQDDHr/jh2Jy4yALcK4JyWbVkPRaWmhck3IgCoeOO3z1e2dBowLh64QAM+Qb72pxekALga2oi4GvT+TlWNhzPH4V example\",\n    }\n\n    transfer, _, err := client.Keys.Create(ctx, createRequest)\n}"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nssh_key = DropletKit::SSHKey.new(\n  name: 'My SSH Public Key',\n  public_key: 'ssh-rsa AEXAMPLEaC1yc2EAAAADAQABAAAAQQDDHr/jh2Jy4yALcK4JyWbVkPRaWmhck3IgCoeOO3z1e2dBowLh64QAM+Qb72pxekALga2oi4GvT+TlWNhzPH4V example'\n)\nclient.ssh_keys.create(ssh_key)"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\nreq = {\n  \"public_key\": \"ssh-rsa AEXAMPLEaC1yc2EAAAADAQABAAAAQQDDHr/jh2Jy4yALcK4JyWbVkPRaWmhck3IgCoeOO3z1e2dBowLh64QAM+Qb72pxekALga2oi4GvT+TlWNhzPH4V example\",\n  \"name\": \"My SSH Public Key\"\n}\n\nresp = client.ssh_keys.create(body=req)"}],"security":[{"bearer_auth":["ssh_key:create"]}]}},"/v2/account/keys/{ssh_key_identifier}":{"get":{"operationId":"sshKeys_get","summary":"Retrieve an Existing SSH Key","description":"To get information about a key, send a GET request to `/v2/account/keys/$KEY_ID` or `/v2/account/keys/$KEY_FINGERPRINT`.\nThe response will be a JSON object with the key `ssh_key` and value an ssh_key object which contains the standard ssh_key attributes.","tags":["SSH Keys"],"parameters":[{"$ref":"#/components/parameters/ssh_key_identifier"}],"responses":{"200":{"$ref":"#/components/responses/sshKeys_existing"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/account/keys/512190\" "},{"lang":"Go","source":"import (\n    \"context\"\n    \"os\"\n\n    \"github.com/digitalocean/godo\"\n)\n\nfunc main() {\n    token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n    client := godo.NewFromToken(token)\n    ctx := context.TODO()\n\n    key, _, err := client.Keys.GetByID(ctx, 512190)\n}"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nclient.ssh_keys.find(id: 512190) "},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\nresp = client.ssh_keys.get(ssh_key_identifier=512190)"}],"security":[{"bearer_auth":["ssh_key:read"]}]},"put":{"operationId":"sshKeys_update","summary":"Update an SSH Key's Name","description":"To update the name of an SSH key, send a PUT request to either `/v2/account/keys/$SSH_KEY_ID` or `/v2/account/keys/$SSH_KEY_FINGERPRINT`. Set the `name` attribute to the new name you want to use.","tags":["SSH Keys"],"parameters":[{"$ref":"#/components/parameters/ssh_key_identifier"}],"requestBody":{"description":"Set the `name` attribute to the new name you want to use.","required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"$ref":"#/components/schemas/ssh_key_name"}}}}}},"responses":{"200":{"$ref":"#/components/responses/sshKeys_existing"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X PUT \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  -d '{\"name\":\"Renamed SSH Key\"}' \\\n  \"https://api.digitalocean.com/v2/account/keys/512190\""},{"lang":"Go","source":"import (\n    \"context\"\n    \"os\"\n\n    \"github.com/digitalocean/godo\"\n)\n\nfunc main() {\n    token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n    client := godo.NewFromToken(token)\n    ctx := context.TODO()\n\n    updateRequest := &godo.KeyUpdateRequest{\n        Name:      \"Renamed SSH Key\",\n    }\n\n    key, _, err := client.Keys.UpdateByID(ctx, 512190, updateRequest)\n}"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nssh_key = DropletKit::SSHKey.new(name: 'Renamed SSH Key')\nclient.ssh_keys.update(ssh_key, id: 512190)"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\nreq = {\n  \"name\": \"My SSH Public Key\"\n}\n\nresp = client.ssh_keys.update(ssh_key_identifier=512190, body=req)"}],"security":[{"bearer_auth":["ssh_key:update"]}]},"delete":{"operationId":"sshKeys_delete","summary":"Delete an SSH Key","description":"To destroy a public SSH key that you have in your account, send a DELETE request to `/v2/account/keys/$KEY_ID` or `/v2/account/keys/$KEY_FINGERPRINT`.\nA 204 status will be returned, indicating that the action was successful and that the response body is empty.","tags":["SSH Keys"],"parameters":[{"$ref":"#/components/parameters/ssh_key_identifier"}],"responses":{"204":{"$ref":"#/components/responses/no_content"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X DELETE \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/account/keys/512190\" "},{"lang":"Go","source":"import (\n    \"context\"\n    \"os\"\n\n    \"github.com/digitalocean/godo\"\n)\n\nfunc main() {\n    token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n    client := godo.NewFromToken(token)\n    ctx := context.TODO()\n\n    _, err := client.Keys.DeleteByID(ctx, 512190)\n}"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nclient.ssh_keys.delete(id: 512190)"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\nresp = client.ssh_keys.delete(ssh_key_identifier=512190)"}],"security":[{"bearer_auth":["ssh_key:delete"]}]}},"/v2/actions":{"get":{"operationId":"actions_list","summary":"List All Actions","description":"This will be the entire list of actions taken on your account, so it will be quite large. As with any large collection returned by the API, the results will be paginated with only 20 on each page by default.","tags":["Actions"],"parameters":[{"$ref":"#/components/parameters/per_page"},{"$ref":"#/components/parameters/page"}],"responses":{"200":{"$ref":"#/components/responses/actions"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/actions?page=1&per_page=1\""},{"lang":"Go","source":"import (\n  \"context\"\n    \"os\"\n\n  \"github.com/digitalocean/godo\"\n  )\n\nfunc main() {\n  token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n  client := godo.NewFromToken(token)\n  ctx := context.TODO()\n\n  opt := &godo.ListOptions{\n      Page:    1,\n      PerPage: 200,\n  }\n  actions, _, err := client.Actions.List(ctx, opt)\n  }"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nactions = client.actions.all\nactions.each"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.getenv(\"$DIGITALOCEAN_TOKEN\"))\n\nlist_resp = client.actions.list()"}],"security":[{"bearer_auth":["actions:read"]}]}},"/v2/actions/{action_id}":{"get":{"operationId":"actions_get","summary":"Retrieve an Existing Action","description":"To retrieve a specific action object, send a GET request to `/v2/actions/$ACTION_ID`.","tags":["Actions"],"parameters":[{"$ref":"#/components/parameters/action_id"}],"responses":{"200":{"$ref":"#/components/responses/action"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/actions/36804636\""},{"lang":"Go","source":"import (\n    \"context\"\n    \"os\"\n\n    \"github.com/digitalocean/godo\"\n)\n\nfunc main() {\n    token := os.Getenv(\"DIGITALOCEAN_TOKEN\")\n\n    client := godo.NewFromToken(token)\n    ctx := context.TODO()\n\n    action, _, err := client.Actions.Get(ctx, 36804636)\n}"},{"lang":"Ruby","source":"require 'droplet_kit'\ntoken = ENV['DIGITALOCEAN_TOKEN']\nclient = DropletKit::Client.new(access_token: token)\n\nclient.actions.find(id: 36804636)"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.getenv(\"$DIGITALOCEAN_TOKEN\"))\n\nget_resp = client.actions.get(action_id=36804636)"}],"security":[{"bearer_auth":["actions:read"]}]}},"/v2/add-ons/apps":{"get":{"operationId":"addons_get_app","summary":"List Available Add-On Applications","description":"To fetch details of all available Add-On Applications, send a GET request to `/v2/add-ons/apps`.\n","tags":["Add-Ons"],"responses":{"200":{"$ref":"#/components/responses/addons_get_app"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/add-ons/apps\" "}],"security":[{"bearer_auth":[]}]}},"/v2/add-ons/apps/{app_slug}/metadata":{"get":{"operationId":"addons_get_app_metadata","summary":"Get Metadata for an Add-On Application","description":"To find out what metadata is required for a specific add-on, send a GET request to `/v2/add-ons/apps/{app_slug}/metadata`.\nMetadata varies by application.\n","tags":["Add-Ons"],"parameters":[{"name":"app_slug","in":"path","required":true,"example":"example_app","schema":{"type":"string"},"description":"The slug identifier for the application whose metadata is being requested."}],"responses":{"200":{"$ref":"#/components/responses/addons_get_app_metadata"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/add-ons/apps/example-app/metadata\" "}],"security":[{"bearer_auth":[]}]}},"/v2/add-ons/saas":{"get":{"operationId":"addons_list","summary":"List all Add-On Resources","description":"To fetch all Add-On Resources under your team, send a GET request to `/v2/add-ons/saas`.\n","tags":["Add-Ons"],"responses":{"200":{"$ref":"#/components/responses/addons_list"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/add-ons/saas\" "}],"security":[{"bearer_auth":["addon:read"]}]},"post":{"operationId":"addons_create","summary":"Create/Provision a New Add-on Resource","description":"To create an add-on resource, send a POST request to `/v2/add-ons/saas` with required parameters.\nSome add-ons require additional metadata to be provided in the request body. To find out\nwhat metadata is required for a specific add-on, send a GET request to `/v2/add-ons/apps/{app_slug}/metadata`.\n","tags":["Add-Ons"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/addons_resource_new"}],"required":["name","app_slug","plan_slug","metadata"]}}}},"responses":{"200":{"$ref":"#/components/responses/addons_create"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X POST \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  -d '{\"name\":\"my-addon-resource\", \"app_slug\": \"example-app\", \"plan_slug\": \"basic_plan\", \"metadata\": [{\"name\": \"company_name\", \"value\": \"Sample Company\"}]}' \\\n  \"https://api.digitalocean.com/v2/add-ons/saas\""}],"security":[{"bearer_auth":["addon:create"]}]}},"/v2/add-ons/saas/{resource_uuid}":{"get":{"operationId":"addons_get","summary":"Get details on an Add-On Resource","description":"To fetch details of a specific Add-On Resource, send a GET request to `/v2/add-ons/saas/{resource_uuid}`.\nReplace `{resource_uuid}` with the UUID of the resource you want to retrieve.\n","tags":["Add-Ons"],"parameters":[{"name":"resource_uuid","in":"path","required":true,"example":"123e4567-e89b-12d3-a456-426614174000","schema":{"type":"string"},"description":"The UUID of the add-on resource to retrieve."}],"responses":{"200":{"$ref":"#/components/responses/addons_get"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/add-ons/saas/123e4567-e89b-12d3-a456-4266141\" "}],"security":[{"bearer_auth":["addon:read"]}]},"delete":{"operationId":"addons_delete","summary":"Delete/Deprovision an Add-on Resource","description":"To delete an add-on resource, send a DELETE request to `/v2/add-ons/saas/{resource_uuid}` with the UUID of the resource to delete. \nYou cannot retrieve the resource after it has been deleted. The response indicates a request was sent to the 3rd party add-on provider to delete the resource.\nYou will no longer be billed for this resource.\n","tags":["Add-Ons"],"parameters":[{"$ref":"#/components/parameters/resource_uuid"}],"responses":{"200":{"$ref":"#/components/responses/no_content"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X DELETE \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/add-ons/saas/123e4567-e89b-12d3-a456-426614174000\""}],"security":[{"bearer_auth":["addon:delete"]}]},"patch":{"operationId":"addons_patch","summary":"Update the name for an Add-On Resource","description":"To change the name of an Add-On Resource, send a PATCH request to `/v2/add-ons/saas/{resource_uuid}`.\nReplace `{resource_uuid}` with the UUID of the resource for which you want to change the name.\n","tags":["Add-Ons"],"parameters":[{"name":"resource_uuid","in":"path","required":true,"example":"123e4567-e89b-12d3-a456-426614174000","schema":{"type":"string"},"description":"The UUID of the add-on resource to rename."}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string","description":"The new name for the add-on resource.","example":"new-name"}},"required":["name"]}}}},"responses":{"200":{"$ref":"#/components/responses/addons_update"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X PATCH \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  -d '{\"name\":\"new-name\"}' \\\n  \"https://api.digitalocean.com/v2/add-ons/saas/abc12345-6789-0123-4567-89abcdef0123\""}],"security":[{"bearer_auth":["addon:update"]}]}},"/v2/add-ons/saas/{resource_uuid}/plan":{"patch":{"operationId":"addons_patch_plan","summary":"Update the plan for an Add-On Resource","description":"To change the plan associated with an Add-On Resource, send a PATCH request to `/v2/add-ons/saas/{resource_uuid}/plan`.\nReplace `{resource_uuid}` with the UUID of the resource for which you want to change the plan.\n","tags":["Add-Ons"],"parameters":[{"name":"resource_uuid","in":"path","required":true,"example":"123e4567-e89b-12d3-a456-426614174000","schema":{"type":"string"},"description":"The UUID of the add-on resource to update."}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"plan_slug":{"type":"string","description":"The slug identifier for the new plan to apply to the add-on resource.","example":"basic_plan"}},"required":["plan_slug"]}}}},"responses":{"200":{"$ref":"#/components/responses/addons_update"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X PATCH \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  -d '{\"plan_slug\":\"new-plan\"}' \\\n  \"https://api.digitalocean.com/v2/add-ons/saas/abc12345-6789-0123-4567-89abcdef0123/plan\""}],"security":[{"bearer_auth":["addon:update"]}]}},"/v2/apps":{"get":{"operationId":"apps_list","summary":"List All Apps","description":"List all apps on your account. Information about the current active deployment as well as any in progress ones will also be included for each app.","tags":["Apps"],"parameters":[{"$ref":"#/components/parameters/page"},{"$ref":"#/components/parameters/per_page"},{"$ref":"#/components/parameters/with_projects"}],"responses":{"200":{"$ref":"#/components/responses/list_apps"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/apps\""},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\nget_resp = client.apps.list()"}],"security":[{"bearer_auth":["app:read"]}]},"post":{"operationId":"apps_create","summary":"Create a New App","description":"Create a new app by submitting an app specification. For documentation on app specifications (`AppSpec` objects), please refer to [the product documentation](https://docs.digitalocean.com/products/app-platform/reference/app-spec/).","tags":["Apps"],"parameters":[{"$ref":"#/components/parameters/accept"},{"$ref":"#/components/parameters/content-type"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/apps_create_app_request"},"example":{"spec":{"name":"web-app","region":"nyc","disable_edge_cache":true,"disable_email_obfuscation":false,"enhanced_threat_control_enabled":true,"services":[{"name":"api","github":{"branch":"main","deploy_on_push":true,"repo":"digitalocean/sample-golang"},"run_command":"bin/api","environment_slug":"node-js","instance_count":2,"instance_size_slug":"apps-s-1vcpu-0.5gb","routes":[{"path":"/api"}]}],"egress":{"type":"DEDICATED_IP"},"vpc":{"id":"c22d8f48-4bc4-49f5-8ca0-58e7164427ac"}}}}},"required":true},"responses":{"200":{"$ref":"#/components/responses/new_app"},"401":{"$ref":"#/components/responses/unauthorized"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X POST \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/apps\"\n  -d '{\"spec\":{\"name\":\"web-app\",\"region\":\"nyc\", \\\n  \"services\":[{\"name\":\"api\",\"github\":{\"branch\":\"main\",\\\n  \"deploy_on_push\":true,\"repo\":\"digitalocean/sample-golang\"}, \\\n  \"run_command\":\"bin/api\",\"environment_slug\":\"node-js\", \\\n  \"instance_count\":2,\"instance_size_slug\":\"apps-s-1vcpu-0.5gb\", \\\n  \"routes\":[{\"path\":\"/api\"}]}]}}'"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\ncreate_resp = client.apps.create(\n    {\n        \"spec\": {\n            \"name\": \"web-app\",\n            \"region\": \"nyc\",\n            \"services\": [\n                {\n                    \"name\": \"api\",\n                    \"github\": {},\n                    \"run_command\": \"bin/api\",\n                    \"environment_slug\": \"node-js\",\n                    \"instance_count\": 2,\n                    \"instance_size_slug\": \"apps-s-1vcpu-0.5gb\",\n                    \"routes\": [],\n                }\n            ],\n        }\n    }\n)"}],"security":[{"bearer_auth":["app:create"]}]}},"/v2/apps/{id}":{"delete":{"operationId":"apps_delete","summary":"Delete an App","description":"Delete an existing app. Once deleted, all active deployments will be permanently shut down and the app deleted. If needed, be sure to back up your app specification so that you may re-create it at a later time.","tags":["Apps"],"parameters":[{"$ref":"#/components/parameters/id_app"}],"responses":{"200":{"$ref":"#/components/responses/delete_app"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X DELETE \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/apps/{id}\""},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\ndelete_resp = client.apps.delete(id=\"b7d64052\")"}],"security":[{"bearer_auth":["app:delete"]}]},"get":{"operationId":"apps_get","summary":"Retrieve an Existing App","description":"Retrieve details about an existing app by either its ID or name. To retrieve an app by its name, do not include an ID in the request path. Information about the current active deployment as well as any in progress ones will also be included in the response.","tags":["Apps"],"parameters":[{"$ref":"#/components/parameters/id_app"},{"$ref":"#/components/parameters/app_name"}],"responses":{"200":{"$ref":"#/components/responses/apps_get"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X GET \\\n  -H \"Content-Type: application/json\" \\\n  -H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n  \"https://api.digitalocean.com/v2/apps/{id}\""},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\n\ncreate_resp = client.apps.get(id=\"4f6c71e2\")"}],"security":[{"bearer_auth":["app:read"]}]},"put":{"operationId":"apps_update","summary":"Update an App","description":"Update an existing app by submitting a new app specification. For documentation on app specifications (`AppSpec` objects), please refer to [the product documentation](https://docs.digitalocean.com/products/app-platform/reference/app-spec/).","tags":["Apps"],"parameters":[{"$ref":"#/components/parameters/id_app"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/apps_update_app_request"}}},"required":true},"responses":{"200":{"$ref":"#/components/responses/update_app"},"401":{"$ref":"#/components/responses/unauthorized"},"404":{"$ref":"#/components/responses/not_found"},"429":{"$ref":"#/components/responses/too_many_requests"},"500":{"$ref":"#/components/responses/server_error"},"default":{"$ref":"#/components/responses/unexpected_error"}},"x-codeSamples":[{"lang":"cURL","source":"curl -X PUT \\\n-H \"Content-Type: application/json\" \\\n-H \"Authorization: Bearer $DIGITALOCEAN_TOKEN\" \\\n\"https://api.digitalocean.com/v2/apps/{id}\" \\\n-d '{\"alerts\":[{\"rule\":\"DEPLOYMENT_FAILED\"},{\"rule\":\"DOMAIN_FAILED\"}],\"domains\":[{\"domain\":\"example.com\",\"type\":\"PRIMARY\",\"zone\":\"example.com\"}],\"envs\":[{\"key\":\"API_KEY\",\"scope\":\"RUN_AND_BUILD_TIME\",\"type\":\"SECRET\",\"value\":\"EV[1:zqiRIeaaYK/NqctZDYzy6t0pTrtRDez8:wqGpZRrsKN5nPhWQrS479cfBiXT0WQ==]\"}],\"features\":[\"buildpack-stack=ubuntu-22\"],\"ingress\":{},\"name\":\"example-app\",\"region\":\"nyc\",\"services\":[{\"autoscaling\":{\"max_instance_count\":4,\"metrics\":{\"cpu\":{\"percent\":70}},\"min_instance_count\":2},\"git\":{\"branch\":\"main\",\"repo_clone_url\":\"https://github.com/digitalocean/sample-nodejs.git\"},\"internal_ports\":[8080],\"log_destinations\":[{\"name\":\"your_log_consumer_name\",\"open_search\":{\"endpoint\":\"logs.example.com:12345\",\"basic_auth\":{\"user\":\"doadmin\",\"password\":\"1234567890abcdef\"},\"index_name\":\"example-index\",\"cluster_name\":\"example-cluster\"}}],\"name\":\"sample-nodejs\",\"run_command\":\"yarn start\",\"source_dir\":\"/\"}]}'"},{"lang":"Python","source":"import os\nfrom pydo import Client\n\nclient = Client(token=os.environ.get(\"DIGITALOCEAN_TOKEN\"))\nreq = {\n\"spec\": {\n    \"name\": \"web-app-01\",\n    \"region\": \"nyc\",\n    \"domains\": [\n        {\n            \"domain\": \"app.example.com\",\n            \"type\": \"DEFAULT\",\n            \"wildcard\": True,\n            \"zone\": \"example.com\",\n            \"minimum_tls_version\": \"1.3\",\n        }\n    ],\n    \"services\": [],\n    \"static_sites\": [\n        {\n            \"cors\": {\n                \"allow_origins\": [\n                    {\"exact\": \"https://www.example.com\"},\n                    {\"regex\": \"^.*example.com\"},\n                ],\n                \"allow_methods\": [\n                    \"GET\",\n                    \"OPTIONS\",\n                    \"POST\",\n                    \"PUT\",\n                    \"PATCH\",\n                    \"DELETE\",\n                ],\n                \"allow_headers\": [\"Content-Type\", \"X-Custom-Header\"],\n                \"expose_headers\": [\"Content-Encoding\", \"X-Custom-Header\"],\n                \"max_age\": \"5h30m\",\n                \"allow_credentials\": False,\n            },\n            \"routes\": [{\"path\": \"/api\", \"preserve_path_prefix\": True}],\n        }\n    ],\n    \"jobs\": [\n        {\n            \"name\": \"api\",\n            \"gitlab\": {\n                \"branch\": \"main\",\n                \"deploy_on_push\": True,\n                \"repo\": \"digitalocean/sample-golang\",\n            },\n            \"image\": {\n                \"registry\": \"registry.hub.docker.com\",\n                \"registry_type\": \"DOCR\",\n                \"repository\": \"origin/master\",\n                \"tag\": \"latest\",\n            },\n            \"dockerfile_path\": \"path/to/Dockerfile\",\n            \"build_command\": \"npm run build\",\n            \"run_command\": \"bin/api\",\n            \"source_dir\": \"path/to/dir\",\n            \"envs\": [\n                {\n                    \"key\": \"BASE_URL\",\n                    \"scope\": \"BUILD_TIME\",\n                    \"type\": \"GENERAL\",\n                    \"value\": \"http://example.com\",\n                }\n            ],\n            \"environment_slug\": \"node-js\",\n            \"log_destinations\": {\n                \"name\": \"my_log_destination\",\n                \"papertrail\": {\n                    \"endpoint\": \"https://mypapertrailendpoint.com\"\n                },\n                \"datadog\": {\n                    \"endpoint\": \"https://mydatadogendpoint.com\",\n                    \"api_key\": \"abcdefghijklmnopqrstuvwxyz0123456789\",\n                },\n                \"logtail\": {\n                    \"token\": \"abcdefghijklmnopqrstuvwxyz0123456789\"\n                },\n               \"open_search\": {\n                    \"endpoint\": \"https://myopensear
[...]
